# -*- coding:cp949 -*-
# ModCodec.py

URL_ENDECODE = 0
HEX_ENDECODE = 1
BASE64_ENDECODE = 2

import re
import urllib

import utils,  sys

try:
    from PyQt4 import QtCore
except ImportError:
    utils.printerror("Can't import QtCore")
    sys.exit(1)

    
class ModCodec():
    def __init__(self, encode=True, function=URL_ENDECODE):
        # If isEncoding is set True, the class encodes input string
        self.m_IsEncoding = encode
        self.m_Function = function
        self.m_InputStr = u''
        self.m_OutputStr = u''
        self.FUNCTION = {URL_ENDECODE:self.URLEncode, HEX_ENDECODE:self.HEXEncode, BASE64_ENDECODE:self.BASE64Encode}

    def Operation(self, input):
        self.m_InputStr = input
        self.FUNCTION[self.m_Function](self.m_IsEncoding)
        if len(self.m_OutputStr) is not 0:
            return self.m_OutputStr
        else:
            return None

    def URLEncode(self, type):
        input = self.m_InputStr.__str__()
        if type is True:                    # Encoding Process
            for ch in input:
                if ch.isalnum() or ch in ['$','&','+',',','/',':',';','=','?','@']:
                    self.m_OutputStr += ch
                else:
                    self.m_OutputStr += ('%'+hex(ord(ch))[2:])
        else:                                  # Decoding Process
            self.m_OutputStr = urllib.unquote(input)


    def HEXEncode(self, type):
        if type is True:                    # Encoding Process
            input = self.m_InputStr.toLocal8Bit().toHex()
            for idx in range(0,  input.length(),  2):
                self.m_OutputStr += '\\x'+ input[idx:idx+2]
        else:                                  # Decoding Process
            input = self.m_InputStr.__str__()
            hexdata = "".join(input.split('\\x'))
            array = QtCore.QByteArray()
            for ch in hexdata:
                array.append(ch)
            self.m_OutputStr = QtCore.QByteArray.fromHex(array)
            print array.__str__()
            #for ch in iList:
            #    self.m_OutputStr += chr(ch
            #slist = self.m_InputStr.split('\\x')
            #if slist[0] == '':
            #    slist.pop(0)
            #for ch in slist:
            #    print "ch=",  ch
            #    self.m_OutputStr += chr(int(ch,  16))

    def BASE64Encode(self, type):
        pass
